/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-05 16:09:48 UTC)
 * on 2013-06-10 at 21:18:57 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.reseller.model;

/**
 * JSON template for a subscription.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Enterprise Apps Reseller API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Subscription extends com.google.api.client.json.GenericJson {

  /**
   * Creation time of this subscription in milliseconds since Unix epoch.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.lang.Long creationTime;

  /**
   * The id of the customer to whom the subscription belongs.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String customerId;

  /**
   * Identifies the resource as a Subscription.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * Plan details of the subscription
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Plan plan;

  /**
   * Purchase order id for your order tracking purposes.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String purchaseOrderId;

  /**
   * Renewal settings of the subscription.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private RenewalSettings renewalSettings;

  /**
   * Number/Limit of seats in the new plan.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Seats seats;

  /**
   * Name of the sku for which this subscription is purchased.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String skuId;

  /**
   * Status of the subscription.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String status;

  /**
   * The id of the subscription.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String subscriptionId;

  /**
   * Trial Settings of the subscription.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private TrialSettings trialSettings;

  /**
   * Creation time of this subscription in milliseconds since Unix epoch.
   * @return value or {@code null} for none
   */
  public java.lang.Long getCreationTime() {
    return creationTime;
  }

  /**
   * Creation time of this subscription in milliseconds since Unix epoch.
   * @param creationTime creationTime or {@code null} for none
   */
  public Subscription setCreationTime(java.lang.Long creationTime) {
    this.creationTime = creationTime;
    return this;
  }

  /**
   * The id of the customer to whom the subscription belongs.
   * @return value or {@code null} for none
   */
  public java.lang.String getCustomerId() {
    return customerId;
  }

  /**
   * The id of the customer to whom the subscription belongs.
   * @param customerId customerId or {@code null} for none
   */
  public Subscription setCustomerId(java.lang.String customerId) {
    this.customerId = customerId;
    return this;
  }

  /**
   * Identifies the resource as a Subscription.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Identifies the resource as a Subscription.
   * @param kind kind or {@code null} for none
   */
  public Subscription setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Plan details of the subscription
   * @return value or {@code null} for none
   */
  public Plan getPlan() {
    return plan;
  }

  /**
   * Plan details of the subscription
   * @param plan plan or {@code null} for none
   */
  public Subscription setPlan(Plan plan) {
    this.plan = plan;
    return this;
  }

  /**
   * Purchase order id for your order tracking purposes.
   * @return value or {@code null} for none
   */
  public java.lang.String getPurchaseOrderId() {
    return purchaseOrderId;
  }

  /**
   * Purchase order id for your order tracking purposes.
   * @param purchaseOrderId purchaseOrderId or {@code null} for none
   */
  public Subscription setPurchaseOrderId(java.lang.String purchaseOrderId) {
    this.purchaseOrderId = purchaseOrderId;
    return this;
  }

  /**
   * Renewal settings of the subscription.
   * @return value or {@code null} for none
   */
  public RenewalSettings getRenewalSettings() {
    return renewalSettings;
  }

  /**
   * Renewal settings of the subscription.
   * @param renewalSettings renewalSettings or {@code null} for none
   */
  public Subscription setRenewalSettings(RenewalSettings renewalSettings) {
    this.renewalSettings = renewalSettings;
    return this;
  }

  /**
   * Number/Limit of seats in the new plan.
   * @return value or {@code null} for none
   */
  public Seats getSeats() {
    return seats;
  }

  /**
   * Number/Limit of seats in the new plan.
   * @param seats seats or {@code null} for none
   */
  public Subscription setSeats(Seats seats) {
    this.seats = seats;
    return this;
  }

  /**
   * Name of the sku for which this subscription is purchased.
   * @return value or {@code null} for none
   */
  public java.lang.String getSkuId() {
    return skuId;
  }

  /**
   * Name of the sku for which this subscription is purchased.
   * @param skuId skuId or {@code null} for none
   */
  public Subscription setSkuId(java.lang.String skuId) {
    this.skuId = skuId;
    return this;
  }

  /**
   * Status of the subscription.
   * @return value or {@code null} for none
   */
  public java.lang.String getStatus() {
    return status;
  }

  /**
   * Status of the subscription.
   * @param status status or {@code null} for none
   */
  public Subscription setStatus(java.lang.String status) {
    this.status = status;
    return this;
  }

  /**
   * The id of the subscription.
   * @return value or {@code null} for none
   */
  public java.lang.String getSubscriptionId() {
    return subscriptionId;
  }

  /**
   * The id of the subscription.
   * @param subscriptionId subscriptionId or {@code null} for none
   */
  public Subscription setSubscriptionId(java.lang.String subscriptionId) {
    this.subscriptionId = subscriptionId;
    return this;
  }

  /**
   * Trial Settings of the subscription.
   * @return value or {@code null} for none
   */
  public TrialSettings getTrialSettings() {
    return trialSettings;
  }

  /**
   * Trial Settings of the subscription.
   * @param trialSettings trialSettings or {@code null} for none
   */
  public Subscription setTrialSettings(TrialSettings trialSettings) {
    this.trialSettings = trialSettings;
    return this;
  }

  @Override
  public Subscription set(String fieldName, Object value) {
    return (Subscription) super.set(fieldName, value);
  }

  @Override
  public Subscription clone() {
    return (Subscription) super.clone();
  }

  /**
   * Plan details of the subscription
   */
  public static final class Plan extends com.google.api.client.json.GenericJson {

    /**
     * Interval of the commitment if it is a commitment plan.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private CommitmentInterval commitmentInterval;

    /**
     * Whether the plan is a commitment plan or not.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.Boolean isCommitmentPlan;

    /**
     * The plan name of this subscription's plan.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String planName;

    /**
     * Interval of the commitment if it is a commitment plan.
     * @return value or {@code null} for none
     */
    public CommitmentInterval getCommitmentInterval() {
      return commitmentInterval;
    }

    /**
     * Interval of the commitment if it is a commitment plan.
     * @param commitmentInterval commitmentInterval or {@code null} for none
     */
    public Plan setCommitmentInterval(CommitmentInterval commitmentInterval) {
      this.commitmentInterval = commitmentInterval;
      return this;
    }

    /**
     * Whether the plan is a commitment plan or not.
     * @return value or {@code null} for none
     */
    public java.lang.Boolean getIsCommitmentPlan() {
      return isCommitmentPlan;
    }

    /**
     * Whether the plan is a commitment plan or not.
     * @param isCommitmentPlan isCommitmentPlan or {@code null} for none
     */
    public Plan setIsCommitmentPlan(java.lang.Boolean isCommitmentPlan) {
      this.isCommitmentPlan = isCommitmentPlan;
      return this;
    }

    /**
     * The plan name of this subscription's plan.
     * @return value or {@code null} for none
     */
    public java.lang.String getPlanName() {
      return planName;
    }

    /**
     * The plan name of this subscription's plan.
     * @param planName planName or {@code null} for none
     */
    public Plan setPlanName(java.lang.String planName) {
      this.planName = planName;
      return this;
    }

    @Override
    public Plan set(String fieldName, Object value) {
      return (Plan) super.set(fieldName, value);
    }

    @Override
    public Plan clone() {
      return (Plan) super.clone();
    }

    /**
     * Interval of the commitment if it is a commitment plan.
     */
    public static final class CommitmentInterval extends com.google.api.client.json.GenericJson {

      /**
       * End time of the commitment interval in milliseconds since Unix epoch.
       * The value may be {@code null}.
       */
      @com.google.api.client.util.Key @com.google.api.client.json.JsonString
      private java.lang.Long endTime;

      /**
       * Start time of the commitment interval in milliseconds since Unix epoch.
       * The value may be {@code null}.
       */
      @com.google.api.client.util.Key @com.google.api.client.json.JsonString
      private java.lang.Long startTime;

      /**
       * End time of the commitment interval in milliseconds since Unix epoch.
       * @return value or {@code null} for none
       */
      public java.lang.Long getEndTime() {
        return endTime;
      }

      /**
       * End time of the commitment interval in milliseconds since Unix epoch.
       * @param endTime endTime or {@code null} for none
       */
      public CommitmentInterval setEndTime(java.lang.Long endTime) {
        this.endTime = endTime;
        return this;
      }

      /**
       * Start time of the commitment interval in milliseconds since Unix epoch.
       * @return value or {@code null} for none
       */
      public java.lang.Long getStartTime() {
        return startTime;
      }

      /**
       * Start time of the commitment interval in milliseconds since Unix epoch.
       * @param startTime startTime or {@code null} for none
       */
      public CommitmentInterval setStartTime(java.lang.Long startTime) {
        this.startTime = startTime;
        return this;
      }

      @Override
      public CommitmentInterval set(String fieldName, Object value) {
        return (CommitmentInterval) super.set(fieldName, value);
      }

      @Override
      public CommitmentInterval clone() {
        return (CommitmentInterval) super.clone();
      }

    }
  }

  /**
   * Trial Settings of the subscription.
   */
  public static final class TrialSettings extends com.google.api.client.json.GenericJson {

    /**
     * Whether the subscription is in trial.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.Boolean isInTrial;

    /**
     * End time of the trial in milliseconds since Unix epoch.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key @com.google.api.client.json.JsonString
    private java.lang.Long trialEndTime;

    /**
     * Whether the subscription is in trial.
     * @return value or {@code null} for none
     */
    public java.lang.Boolean getIsInTrial() {
      return isInTrial;
    }

    /**
     * Whether the subscription is in trial.
     * @param isInTrial isInTrial or {@code null} for none
     */
    public TrialSettings setIsInTrial(java.lang.Boolean isInTrial) {
      this.isInTrial = isInTrial;
      return this;
    }

    /**
     * End time of the trial in milliseconds since Unix epoch.
     * @return value or {@code null} for none
     */
    public java.lang.Long getTrialEndTime() {
      return trialEndTime;
    }

    /**
     * End time of the trial in milliseconds since Unix epoch.
     * @param trialEndTime trialEndTime or {@code null} for none
     */
    public TrialSettings setTrialEndTime(java.lang.Long trialEndTime) {
      this.trialEndTime = trialEndTime;
      return this;
    }

    @Override
    public TrialSettings set(String fieldName, Object value) {
      return (TrialSettings) super.set(fieldName, value);
    }

    @Override
    public TrialSettings clone() {
      return (TrialSettings) super.clone();
    }

  }
}
